chiark / gitweb /
Test suite: orig-include-exclude: Refactor: introduce test-push-[12]
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-filter-out-git-hyphen-dir
25
26 t-set-intree
27
28 : ${DGIT_TEST_DEBUG=-D}
29 export DGIT_TEST_DEBUG
30
31 export GIT_COMMITTER_DATE='1440253867 +0100'
32 export GIT_AUTHOR_DATE='1440253867 +0100'
33
34 root=`pwd`
35 troot=$root/tests
36 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
37
38 tmp=$ADTTMP
39 if [ x"$tmp" = x ]; then
40         mkdir -p tests/tmp
41         tmpbase=$troot/tmp
42         tmp=tests/tmp/$testname
43         rm -rf $tmp
44         mkdir $tmp
45 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
46         tmpbase="$DGIT_TEST_TMPBASE"
47 fi
48 cd $tmp
49
50 tmp=`pwd`
51
52 t-set-using-tmp
53
54 env -0 >$tmp/.save-env
55
56 ln -f $troot/ssh ssh
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${tagpfx:=archive/test-dummy}
69 : ${suitespecs:=sid:unstable}
70
71 t-git-next-date () {
72         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
73         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
74 }
75
76 t-expect-fail () {
77         local mpat="$1"; shift
78
79         set +o pipefail
80         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
81         local ps="${PIPESTATUS[*]}"
82         set -o pipefail
83
84         case $ps in
85         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
86         *" 0")  ;;
87         *)      fail "tee failed"  ;;
88         esac
89
90         t-grep-mpat "$mpat" $tmp/t.output
91 }
92
93 t-grep-mpat () {
94         local mpat="$1"
95         local file="$2"
96
97         local grepper=fgrep
98         case "$mpat" in
99         [A-Z]:*)
100                 case "$mpat" in
101                 E:*)    grepper=egrep   ;;
102                 F:*)    grepper=fgrep   ;;
103                 *)      fail "bad mpat prefix in $mpat";;
104                 esac
105                 mpat=${mpat#[A-Z]:}
106                 ;;
107         esac
108
109         $grepper -e "$mpat" "$file" ||
110                 fail "message not found"
111 }
112
113 t-expect-push-fail () {
114         local mpat="$1"; shift
115
116         local triedpush=`git rev-parse HEAD`
117
118         t-reporefs pre-push
119         t-expect-fail "$mpat"  "$@"
120         t-reporefs post-push
121         diff $tmp/show-refs.{pre,post}-push
122
123         t-git-objects-not-present '' $triedpush
124
125         eval "$t_expect_push_fail_hook"
126 }
127
128 t-git-objects-not-present () {
129         # t-git-objects-not-present GITDIR|'' OBJID [...]
130         # specifying '' means the repo for package $p
131         local gitdir="${1-$dgitrepo}"
132         local obj
133         if ! [ -e "$gitdir" ]; then return; fi
134         for obj in "$@"; do
135                 GIT_DIR=$gitdir \
136                 t-expect-fail 'unable to find' \
137                 git cat-file -t $obj
138         done
139 }
140
141 t-reporefs () {
142         local whichoutput=$1; shift
143         local whichrepo=${1-$dgitrepo}
144         local outputfile="$tmp/show-refs.$whichoutput"
145         (set -e
146          exec >"$outputfile"
147          if test -d $whichrepo; then
148                 cd $whichrepo
149                 git show-ref |sort
150         fi)
151 }
152
153 t-untar () {
154         local tarfile=$1.tar
155         local edittree=$1.edit
156         if test -d "$edittree"; then
157                 cp -a "$edittree"/* .
158         else
159                 tar xf "$tarfile"
160         fi
161 }
162
163 t-worktree () {
164         rm -rf $p
165         t-untar $troot/worktrees/${p}_$1
166 }
167
168 t-select-package () {
169         p=$1
170         dgitrepo=$tmp/git/$p.git
171 }
172
173 t-git () {
174         t-select-package $1
175         v=$2
176         mkdir -p $tmp/git
177         local gs=$troot/git-srcs/${p}_$v.git
178         (set -e; cd $tmp/git; t-untar $gs)
179 }
180
181 t-git-none () {
182         mkdir -p $tmp/git
183         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
184 }
185
186 t-git-merge-base () {
187         git merge-base $1 $2 || test $? = 1
188 }
189
190 t-has-ancestor () {
191         local now=`git rev-parse HEAD`
192         local ancestor=`git rev-parse $1^{}`
193         local mbase=`t-git-merge-base $ancestor $now`
194         if [ x$mbase != x$ancestor ]; then
195                 fail "not ff $ancestor..$now, $mbase != $ancestor"
196         fi
197 }
198
199 t-prep-newpackage () {
200         t-select-package $1
201         v=$2
202         t-archive-none $p
203         t-git-none
204         t-worktree $v
205         cd $p
206         if ! git show-ref --verify --quiet refs/heads/master; then
207                 git branch -m dgit/sid master
208                 git remote rm dgit
209         fi
210         cd ..
211 }
212
213 t-archive-none () {
214         t-select-package $1
215         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
216
217         : >$tmp/aq/suites
218         local jsondelim="["
219
220         local suitespec
221         for suitespec in $suitespecs; do
222                 local suite=${suitespec%%:*}
223                 local sname=${suitespec#*:}
224
225                 >$tmp/aq/package.$suite.$p
226                 t-archive-updated $suite $p
227
228                 >$tmp/aq/package.new.$p
229                 t-archive-updated new $p
230
231                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
232
233                 cat <<END >>$tmp/aq/suites
234 $jsondelim
235    {
236       "archive" : "ftp-master",
237       "codename" : "$suite",
238       "components" : [
239          "main",
240          "contrib",
241          "non-free"
242       ],
243       "name" : "$sname",
244       "dakname" : "$sname"
245 END
246
247                 jsondelim="   },"
248
249         done
250         cat <<END >>$tmp/aq/suites
251     }
252 ]
253 END
254 }
255
256 t-archive-updated () {
257         local suite=$1
258         local p=$2
259         local suitedir=$tmp/aq/dsc_in_suite/$suite
260         mkdir -p $suitedir
261         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
262                 use JSON;
263                 use strict;
264                 our @v;
265                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
266                 push @v, {
267                         "version" => "$1",
268                         "sha256sum" => "$2",
269                         "component" => "$3",
270                         "filename" => "$4",
271                 };
272                 END {
273                         my $json = JSON->new->canonical();
274                         print $json->encode(\@v) or die $!;
275                 }
276         '
277 }
278
279 t-archive-process-incoming () {
280         local suite=$1
281         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
282         t-archive-query "$suite"
283 }
284
285 t-archive-query () {
286         local suite=${1-sid}
287         local dscf=main/${p}_${v}.dsc
288         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
289         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
290         t-archive-updated $suite $p
291 }
292
293 t-archive () {
294         t-archive-none $1
295         v=$2
296         local dscf=${p}_$2.dsc
297         rm -f $tmp/mirror/pool/main/${p}_*
298         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
299         t-archive-query
300         rm -rf $tmp/extract
301         mkdir $tmp/extract
302         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
303 }
304
305 t-git-dir-time-passes () {
306         touch -d 'last year' $dgitrepo
307 }
308
309 t-git-dir-check () {
310         local gitdir=$dgitrepo
311         case "$1" in
312         enoent)
313                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
314                 return
315                 ;;
316         public) wantstat='7[75]5' ;;
317         secret) wantstat='7[70]0' ;;
318         *)      fail "$1 t-git-dir-check ?" ;;
319         esac
320         gotstat=`stat -c%a $gitdir`
321         case "$gotstat" in
322         *$wantstat) return ;;
323         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
324         esac
325 }
326
327 t-rm-dput-dropping () {
328         rm -f $tmp/${p}_${v}_*.upload
329 }
330
331 t-dgit () {
332         local dgit=${DGIT_TEST-dgit}
333         pwd
334         : '
335 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
336         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
337                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
338                 -k39B13D8A $t_dgit_xopts "$@"
339         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
340 '
341 }
342
343 t-diff-nogit () {
344         diff --exclude=.git --exclude=.pc -ruN $*
345 }
346
347 t-files-notexist () {
348         local f
349         for f in "$@"; do
350                 if [ -e $f ]; then
351                         fail "$f exists!"
352                 fi
353         done
354 }
355
356 t-cloned-fetched-good () {
357         t-diff-nogit ../extract/$p-${v%-*} .
358         t-clean-on-branch dgit/sid
359         t-refs-same-start
360         t-refs-same \
361                 refs/heads/dgit/sid \
362                 refs/remotes/dgit/dgit/sid
363         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
364 }
365
366 t-output () {
367         printf "%s${1:+\n}" "$1" >$tmp/t.want
368         shift
369         "$@" >$tmp/t.got
370         diff $tmp/t.want $tmp/t.got
371 }
372
373 t-clean-on-branch () {
374         t-output "## $1" git status -b --porcelain
375 }
376
377 t-setup-done () {
378         local savevars=$1
379         local savedirs=$2
380         local importeval=$3
381
382         local import=IMPORT.${0##*/}
383         exec 4>$tmp/$import.new
384
385         local vn
386         for vn in $savevars; do
387                 perl >&4 -I. -MDebian::Dgit -e '
388                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
389                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
390         done
391
392         (set -e; cd $tmp; tar cf $import.tar $savedirs)
393
394         printf >&4 "\n%s\n" "$importeval"
395
396         mv -f $tmp/$import.new $tmp/$import
397 }
398
399 t-setup-import () {
400         local setupname=$1
401
402         local setupsrc
403         local lock
404         if [ "x$tmpbase" = x ]; then
405                 # ADTTMP was set on entry to tests/lib, so we
406                 # are not sharing tmp area between tests
407                 setupsrc="$tmp"
408                 lock="$tmp/.dummy.lock"
409         else
410                 setupsrc="$tmpbase/$setupname"
411                 lock="$setupsrc.lock"
412         fi
413
414         local simport="$setupsrc/IMPORT.$setupname"
415
416         if ! [ -e "$simport" ]; then
417                 with-lock-ex -w "$lock" \
418                 xargs -0 -a $tmp/.save-env \
419                 bash -xec '
420                         cd "$1"; shift
421                         setupname="$1"; shift
422                         simport="$1"; shift
423                         if [ -e "$simport" ]; then exit 0; fi
424                         env - "$@" \
425                         "tests/setup/$setupname"
426                 ' x "$root" "$setupname" "$simport"
427         fi
428
429         if [ "x$setupsrc" != "x$tmp" ]; then
430                 (set -e; cd $tmp; tar xf "$simport.tar")
431         fi
432
433         . "$simport"
434 }
435
436 t-git-get-ref-exact () {
437         local ref=$1
438         # does not dereference, unlike t-git-get-ref
439         case "$ref" in
440         refs/*) ;;
441         *) fail "t-git-get-ref-exact bad $ref" ;;
442         esac
443         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
444 }
445
446 t-git-get-ref () {
447         local ref=$1
448         case "$ref" in
449         refs/*) ;;
450         *) fail "t-git-get-ref bad $ref" ;;
451         esac
452         (git show-ref -d $1 || test $? = 1) | perl -ne '
453                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
454                 END { print "$x\n" if length $x; }
455         '
456 }
457
458 t-ref-same-exact () {
459         local name="$1"
460         local val=`t-git-get-ref-exact $name`
461         t-ref-same-val "$name" $val
462 }
463
464 t-ref-same () {
465         local name="$1"
466         local val=`t-git-get-ref $name`
467         t-ref-same-val "$name" $val
468 }
469
470 t-ref-head () {
471         local val=`git rev-parse HEAD`
472         t-ref-same-val HEAD $val
473 }
474
475 t-ref-same-val () {
476         local name="$1"
477         local val=$2
478         case "$t_ref_val" in
479         '')             ;;
480         "$val")         ;;
481         *)              fail "ref varies: $name:\
482  ${val:-nothing} != ${t_ref_val:-nothing}" ;;
483         esac
484         t_ref_val="$val"
485 }
486
487 t-refs-same-start () {
488         t_ref_val=''
489 }
490
491 t-refs-same () {
492         local g
493         for g in $*; do
494                 t-ref-same $g
495         done
496 }
497
498 t-refs-notexist () {
499         local val
500         for g in $*; do
501                 val=`t-git-get-ref $g`
502                 if [ "x$val" != x ]; then
503                         fail "ref $g unexpectedly exists ($val)"
504                 fi
505         done
506 }
507
508 t-v-tag () {
509         echo refs/tags/$tagpfx/${v//\~/_}
510 }
511
512 t-format-ref () {
513         git log -n1 --pretty=format:"$1" "$2"
514 }
515
516 t-sametree-parent () {
517         local ref=$1
518         local parent
519         local ctree=$(t-format-ref '%T' "$ref")
520         while :; do
521                 local psame=''
522                 for parent in $(t-format-ref '%P' "$ref"); do
523                         local ptree=$(t-format-ref '%T' "$parent")
524                         if [ "x$ptree" = "x$ctree" ]; then
525                                 psame+=" $parent"
526                         fi
527                 done
528                 case "$psame" in ""|" * *") break ;; esac
529                 ref="${psame# }"
530         done
531         echo "$ref"
532 }
533
534 t-check-pushed-master () {
535         local master=`t-git-get-ref refs/heads/master`
536         if [ x$master = x$t_ref_val ]; then return; fi
537         if [ x$master = x ]; then fail "failed to push master"; fi
538         # didn't update master, it must be not FF
539         local mbase=`t-git-merge-base $master $t_ref_val`
540         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
541 }
542
543 t-pushed-good () {
544         local branch=$1
545         local suite=${2:-sid}
546         t-refs-same \
547                 refs/heads/$branch
548         t-pushed-good-core
549 }
550         
551 t-pushed-good-core () {
552         t-ref-dsc-dgit
553         t-refs-same \
554                 `t-v-tag` \
555                 refs/remotes/dgit/dgit/$suite
556         t-refs-notexist \
557                 refs/heads/dgit/unstable \
558                 refs/remotes/dgit/dgit/unstable
559         (set -e; cd $dgitrepo
560          t-refs-same \
561                 refs/dgit/$suite \
562                 `t-v-tag`
563          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
564          t-refs-notexist \
565                 refs/dgit/unstable
566         )
567         git verify-tag `t-v-tag`
568 }
569
570 t-splitbrain-pushed-good--unpack () {
571         cd $tmp
572         rm -rf t-unpack
573         mkdir t-unpack
574         cd t-unpack
575         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
576         ln -s $incoming_dsc .
577         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
578         dpkg-source "$@" -x *.dsc
579         cd */.
580         git init
581         git fetch ../../$p "refs/tags/*:refs/tags/*"
582 }
583
584 t-splitbrain-pushed-good--checkprep () {
585         git add -Af .
586         git rm --cached -r --ignore-unmatch .pc
587 }
588
589 t-splitbrain-pushed-good--checkdiff () {
590         local tag=$1
591         t-splitbrain-pushed-good--checkprep
592         t-output "" git diff --stat --cached $tag
593 }
594
595 t-splitbrain-pushed-good-start () {
596         dep14tag=refs/tags/test-dummy/${v//\~/_}
597         dgittag=$(t-v-tag)
598         t-output "" git status --porcelain
599         t-ref-head
600         t-refs-same $dep14tag
601         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
602         git merge-base --is-ancestor $dep14tag $dgittag
603
604         t-refs-same-start
605         t-pushed-good-core
606
607         t-incoming-dsc
608
609         t-splitbrain-pushed-good--unpack
610         t-splitbrain-pushed-good--checkdiff $dgittag
611 }
612 t-splitbrain-pushed-good-end-made-dep14 () {
613         t-splitbrain-pushed-good--checkdiff $dep14tag
614         cd $tmp/$p
615 }
616
617 t-splitbrain-rm-gitignore-patch () {
618         perl -i -pe '
619                 next unless $_ eq "auto-gitignore\n";
620                 die if $counter++;
621                 chomp;
622                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
623                 $_ = "";
624         ' debian/patches/series
625 }
626
627 t-gbp-pushed-good () {
628         local suite=${1:-sid}
629         t-splitbrain-pushed-good-start
630
631         # Right, now we want to check that the maintainer tree and
632         # the dgit tree differ in exactly the ways we expect.  We
633         # achieve this by trying to reconstruct the maintainer tree
634         # from the dgit tree.
635
636         # So, unpack it withut the patches applied
637         t-splitbrain-pushed-good--unpack --skip-patches
638
639         # dgit might have added a .gitignore patch, which we need to
640         # drop and remove
641         t-splitbrain-rm-gitignore-patch
642
643         # Now the result should differ only in non-debian/ .gitignores
644         t-splitbrain-pushed-good--checkprep
645         git diff --cached --name-only $dep14tag >../changed
646         perl -ne '
647                 next if !m#^debian/# && m#(^|/)\.gitignore#;
648                 die "$_ mismatch";
649         ' <../changed
650
651         # If we actually apply the gitignore patch by hand, it
652         # should be perfect:
653         if [ -f ../t-auto-gitignore ]; then
654                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
655         fi
656
657         t-splitbrain-pushed-good-end-made-dep14
658 }
659
660 t-unapplied-pushed-good () {
661         t-splitbrain-pushed-good-start
662         t-splitbrain-pushed-good--unpack --skip-patches
663         t-splitbrain-pushed-good-end-made-dep14
664 }
665
666 t-dpm-pushed-good () {
667         t-splitbrain-pushed-good-start
668         t-splitbrain-pushed-good--unpack
669         t-splitbrain-rm-gitignore-patch
670         t-splitbrain-pushed-good-end-made-dep14
671 }
672
673 t-commit-build-push-expect-log () {
674         local msg=$1
675         local mpat=$2
676         t-commit "$msg"
677         t-dgit build
678         LC_MESSAGES=C \
679         t-dgit push --new 2>&1 |tee $tmp/push.log
680         t-grep-mpat "$mpat" $tmp/push.log
681 }
682
683 t-822-field () {
684         local file=$1
685         local field=$2
686         perl -e '
687                 use Dpkg::Control::Hash;
688                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
689                 $h->parse(\*STDIN,"'"$file"'");
690                 my $val = $h->{"'$field'"},"\n";
691                 die "'"$file $field"'" unless defined $val;
692                 print $val,"\n";
693         ' <$file
694 }
695
696 t-stunt-envvar () {
697         local var=$1
698         local tstunt=$2
699         eval '
700                 case "$'$var'" in
701                 "$tstunt:"*)    ;;
702                 *":$tstunt:"*)  ;;
703                 "")             '$var'="$tstunt" ;;
704                 *)              '$var'="$tstunt:$'$var'" ;;
705                 esac
706                 export '$var'
707         '
708 }
709
710 t-tstunt () {
711         local tstunt=$tmp/tstunt
712         t-stunt-envvar PATH $tstunt
713         t-stunt-envvar PERLLIB $tstunt
714         local f
715         for f in "$@"; do
716                 f="./$f"
717                 local d="$tstunt/${f%/*}"
718                 mkdir -p $d
719                 ln -sf "$troot/tstunt/$f" "$d"/.
720         done
721 }
722
723 t-tstunt-parsechangelog () {
724         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
725 }
726
727 t-incoming-dsc () {
728         local dsc=${p}_${v}.dsc
729         incoming_dsc=$tmp/incoming/$dsc
730 }
731
732 t-ref-dsc-dgit () {
733         t-incoming-dsc
734         local val=`t-822-field $incoming_dsc Dgit`
735         perl -e '$_=shift @ARGV; die "Dgit $_ ?" unless m/^\w+\b/;' "$val"
736         t-ref-same-val $incoming_dsc "$val"
737 }
738
739 t-apply-diff () {
740         local v1=$1
741         local v2=$2
742         (cd $troot/pkg-srcs;
743          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
744          | patch -p1 -u
745 }
746
747 t-gbp-unapplied-pq2qc () {
748         # does `gbp pq export'
749         # commits the resulting debian/patches on  qc/BRANCH
750         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
751         # qc/BRANCH is not fast-forwarding
752
753         gbp pq export
754
755         branch=`git symbolic-ref HEAD`
756         branch=${branch#refs/heads/}
757
758         case "$branch" in
759         */*) fail "unexpected branch $branch" ;;
760         esac
761
762         git branch -f qc/$branch
763         git checkout qc/$branch
764         git add debian/patches
765         git commit -m 'Commit patch queue'
766 }
767
768 t-git-pseudo-merge () {
769         # like   git merge -s ours
770         if [ ! "$git_pseuomerge_opts" ]; then
771                 if git merge --help \
772                  | grep -q allow-unrelated-histories; then
773                         git_pseuomerge_opts='--allow-unrelated-histories'
774                 fi
775                 git_pseuomerge_opts+=' -s ours'
776         fi
777         git merge $git_pseuomerge_opts "$@"
778 }
779
780 t-gbp-example-prep-no-ff () {
781         t-tstunt-parsechangelog
782         t-archive example 1.0-1
783         t-git-none
784         t-worktree 1.0
785
786         cd example
787
788         t-dgit fetch
789
790         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
791         gbp pq rebase
792
793         echo '/* some comment */' >>src.c
794         git add src.c
795         git commit -m 'Add a comment to an upstream file'
796
797         t-gbp-unapplied-pq2qc
798
799         t-commit 'some updates' 1.0-2
800 }
801
802 t-gbp-example-prep () {
803         t-gbp-example-prep-no-ff
804
805         t-git-pseudo-merge \
806                 -m 'Pseudo-merge to make descendant of archive' \
807                 remotes/dgit/dgit/sid
808 }
809
810 t-commit () {
811         local msg=$1
812         v=${2:-${majorv:-1}.$revision}
813         dch -v$v --distribution ${3:-unstable} "$1"
814         git add debian/changelog
815         debcommit
816         revision=$(( ${revision-0} + 1 ))
817 }
818
819 t-git-config () {
820         git config --global "$@"
821 }
822
823 t-drs () {
824         export DGIT_TEST_TROOT=$troot
825  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
826  t-git-config dgit-distro.test-dummy.git-check true
827  t-git-config dgit-distro.test-dummy.git-create true
828  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
829         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
830         cp $troot/suites $tmp/.
831         cp $troot/suites $tmp/suites-master
832
833         export t_check_pushed_master=t-check-pushed-master
834
835         drs_dispatch=$tmp/distro=test-dummy
836         mkdir $drs_dispatch
837
838         if [ "x$DGIT_TEST_INTREE" != x ]; then
839                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
840         fi
841
842         ln -sf $tmp/git $drs_dispatch/repos
843         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
844         mkdir -p $drs_dispatch/keyrings
845         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
846         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
847         ln -sf /bin/true $drs_dispatch/policy-hook
848 }
849
850 t-newtag () {
851  export tagpfx=archive/test-dummy
852  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
853 }
854 t-oldtag () {
855  export tagpfx=test-dummy
856  t-git-config dgit-distro.test-dummy.dgit-tag-format old
857 }
858
859 t-dsd () {
860         t-drs
861  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
862  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
863  t-git-config dgit-distro.test-dummy.git-create true
864  t-git-config dgit-distro.test-dummy.git-url \
865                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
866
867  t-git-config dgit-distro.test-dummy.diverts.drs /drs
868  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
869  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
870  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
871  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
872
873         echo 'no-such-package* drs' >$drs_dispatch/diverts
874 }
875
876 t-policy-admin () {
877         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
878 }
879
880 t-policy-nonexist () {
881         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
882 }
883
884 t-make-hook-link () {
885         local hook=$1 # in infra/
886         local linkpath=$2
887         hook=${DGIT_INFRA_PFX}$hook
888         case $hook in
889         */*)    ;;
890         *)      hook=`type -P $hook` ;;
891         esac
892         ln -sf "$hook" $linkpath
893 }
894
895 t-policy () {
896         local policyhook=$1
897         t-make-hook-link $policyhook $drs_dispatch/policy-hook
898 }
899
900 t-debpolicy () {
901         t-dsd
902         t-policy dgit-repos-policy-debian
903
904         mkdir $tmp/git
905         t-policy-admin create-db
906 }
907
908 t-policy-periodic () {
909         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
910                 test-dummy $drs_dispatch '' --cron
911 }
912
913 t-restrict () {
914         local restriction=$1
915         (cd $root; t-restriction-$restriction >&2)
916 }
917
918 t-dependencies () {
919         : "Hopefully installed: $*"
920 }
921
922 t-chain-test () {
923         local ct=$1
924         local d=${0%/*}
925         cd $root
926         export DGIT_TEST_TESTNAME="$testname"
927         export DGIT_TEST_TMPBASE="$tmpbase"
928         export ADTTMP=$tmp
929         exec "$d/$ct"
930 }       
931
932 t-alt-test () {
933         local t=${0##*/}
934         t-${t%%-*}
935         t-chain-test "${t#*-}"
936 }
937
938 case "$0" in
939 */gnupg) ;;
940 *)      t-setup-import gnupg    ;;
941 esac